#include "vector2.H"

// Definizione delle classi vector2 e operatori //

vector2::vector2(const vector2 &v) {
x[0]=v.x[0];
x[1]=v.x[1];
}
vector2::vector2(double a,double b)
{
 x[0]=a;x[1]=b;
}
istream& operator>>(istream& c,vector2 &v)
{
  return c>>v.x[0]>>v.x[1];
}
ostream& operator<<(ostream& c,vector2 v)
{
return c<<"("<<v.x[0]<<","<<v.x[1]<<")";
}
vector2 &operator+=(vector2 &a,vector2 b)
{
  a.x[0]+=b.x[0];a.x[1]+=b.x[1];
  return a;
}
vector2 &operator-=(vector2 &a,vector2 b)
{
  a.x[0]-=b.x[0];a.x[1]-=b.x[1];
  return a;
}
vector2 &operator/=(vector2 &a,double k)
{
  a.x[0]/=k;a.x[1]/=k;
  return a;
}
int operator!= (vector2 a,vector2 b)
{
  return !(a.x[0]==b.x[0] && a.x[1]==b.x[1] );
}
vector2 operator+ (vector2 a,vector2 b)
{
  return vector2 (a.x[0]+b.x[0],a.x[1]+b.x[1]);
}
vector2 operator- (vector2 a,vector2 b)
{
  return vector2 (a.x[0]-b.x[0],a.x[1]-b.x[1]);
}
vector2 operator- (vector2 b)
{
  return vector2 (-b.x[0],-b.x[1]);
}
double operator* (vector2 a,vector2 b)
{
  return a.x[0]*b.x[0]+a.x[1]*b.x[1];
}
vector2 operator* (double a,vector2 b)
{
  return vector2(a*b.x[0],a*b.x[1]);
}
vector2 operator/ (vector2 a,double b)
{
  return vector2 (a.x[0]/b,a.x[1]/b);
}
double abs (vector2 a)
{
  return sqrt(a.x[0]*a.x[0]+a.x[1]*a.x[1]);
}
vector2 versor (vector2 v)
{
  double f;
  f=abs(v);
  if (f>0.0)
    return 1.0/abs(v)*v;
  else return v;
}

double sqr (vector2 a)
{
  return a.x[0]*a.x[0]+a.x[1]*a.x[1];
}

